;;; File: "futures.scm"

(##module futures gambit

  (export future touch)

  (define-macro (future exp)
    `(futures##make-future (lambda () ,exp))))

(define-type placeholder results condition failed? complete? thread)

(define (make-future thunk)
  (let* ((f (make-placeholder '() #f #f #f #f))
	 (t (make-thread
	     (lambda ()
	       (with-exception-catcher
                (lambda (ex)
                  (placeholder-condition-set! f ex)
                  (placeholder-failed?-set! f #t))
                (lambda ()
                  (placeholder-results-set!
                   f
                   (call-with-values thunk list))))
	       (placeholder-complete?-set! f #t)))))
    (placeholder-thread-set! f t)
    (thread-start! t)
    f))

(define (touch x)
  (if (placeholder? x)
      (let loop ()
        (cond ((placeholder-failed? x)
               (raise (placeholder-condition x)))
              ((placeholder-complete? x)
               (apply values (placeholder-results x)))
              (else
               (thread-join! (placeholder-thread x))
               (loop))))
      x))
